'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var path = _interopDefault(require('path'));

var extname = path.extname;

var src = function nuxtSassResourcesLoader(options, extensions) {
  if (typeof options === 'string') {
    options = {
      resources: [options]
    };
  }

  if (Array.isArray(options)) {
    options = {
      resources: options
    };
  }

  var sassResourcesLoader = {
    loader: 'sass-resources-loader',
    options: options
  };

  this.extendBuild(function (config, _ref) {
    options.resources.forEach(function (resource) {
      var ext = extensions || extname(resource);
      var styleLoaders = config.module.rules.filter(function (_ref2) {
        var test = _ref2.test;

        return test.exec(ext);
      });

      Object.keys(styleLoaders).forEach(function (loader) {
        styleLoaders[loader].use.push(sassResourcesLoader);
      });

      var vueConfig = config.module.rules.find(function (_ref3) {
        var test = _ref3.test;

        return test.toString() === '/\\.vue$/';
      });

      var vueLoaders = vueConfig.options.loaders;

      Object.keys(vueLoaders).forEach(function (loader) {
        if (ext.indexOf(loader) !== -1) {
          vueLoaders[loader].push(sassResourcesLoader);
        }
      });
    });
  });
};

module.exports = src;
